//
//  CustomChat.m
//  Demo---折线
//
//  Created by BY on 16/10/8.
//  Copyright © 2016年 CWH. All rights reserved.
//

#import "CustomChat.h"

#define titleMargin         25
#define xLabelMargin        15
#define yLabelMargin        15
#define UULabelHeight       25
#define UULabelwidth        30
#define UUTagLabelwidth     80
#define selfWidth           self.bounds.size.width
#define selfHeight           self.bounds.size.height
#define lineWidth           selfWidth - 2*UULabelwidth

@interface CustomChat (){
    UIImageView     *_horizontalImg;
    CGFloat          _leftLastLabelH;
}

@end


@implementation CustomChat

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        self.backgroundColor = [UIColor clearColor];
        _leftTitleColor = [UIColor grayColor];
        _rightTitleColor = [UIColor blackColor];
//        [self initialization];
    }
    return self;
}

- (void)setLeftTitleArray:(NSArray *)leftTitleArray
{
    _leftTitleArray = leftTitleArray;
}

- (void)setRightTitleArray:(NSArray *)rightTitleArray
{
    _rightTitleArray = rightTitleArray;
}

- (void)setLeftTitleColor:(UIColor *)leftTitleColor
{
    _leftTitleColor = leftTitleColor;
}

- (void)setRightTitleColor:(UIColor *)rightTitleColor
{
    _rightTitleColor = rightTitleColor;
}

- (void)setLeftTitle:(NSString *)leftTitle
{
    _leftTitle = leftTitle;
}

- (void)setRightTitle:(NSString *)rightTitle
{
    _rightTitle = rightTitle;
}

- (void)initialization
{
    
    for (int i = 0; i < _rightTitleArray.count; i++) {
        
        if (i == 0) {
            UILabel *rightTitle = [[UILabel alloc] initWithFrame:CGRectMake(lineWidth + UULabelwidth - 70, 0, 100, 25)];
            rightTitle.text = [NSString stringWithFormat:@"%@",_rightTitle];
            rightTitle.textAlignment = NSTextAlignmentRight;
            rightTitle.textColor = _rightTitleColor;
            [self addSubview:rightTitle];
        }
        
        UILabel *rightTitleCompany = [[UILabel alloc] initWithFrame:CGRectMake(lineWidth + UULabelwidth - 10, 25 + i * titleMargin, UULabelwidth, UULabelHeight)];
        rightTitleCompany.text = [NSString stringWithFormat:@"%@",_rightTitleArray[i]];
        rightTitleCompany.font = [UIFont systemFontOfSize:13];
        rightTitleCompany.textAlignment = NSTextAlignmentRight;
        rightTitleCompany.textColor = _rightTitleColor;
        [self addSubview:rightTitleCompany];
    }
    
    for (int i = 0; i < _leftTitleArray.count; i++) {
        
        if (i == 0) {
            UILabel *leftTitle = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, 100, 25)];
            leftTitle.text = [NSString stringWithFormat:@"%@",_leftTitle];
            leftTitle.textAlignment = NSTextAlignmentLeft;
            leftTitle.textColor = _leftTitleColor;
            [self addSubview:leftTitle];
        }
        
        UILabel *leftTitleCompany = [[UILabel alloc] initWithFrame:CGRectMake(0, 25 + i * titleMargin, UULabelwidth, UULabelHeight)];
        leftTitleCompany.text = [NSString stringWithFormat:@"%@",_leftTitleArray[i]];
        leftTitleCompany.textAlignment = NSTextAlignmentRight;
        leftTitleCompany.font = [UIFont systemFontOfSize:13];
        leftTitleCompany.textColor = _leftTitleColor;
        [self addSubview:leftTitleCompany];
        
        
        
        UIImageView  *horizontalImg = [[UIImageView alloc]initWithFrame:CGRectMake(CGRectGetWidth(leftTitleCompany.bounds), 25 + i * titleMargin + UULabelHeight/2, lineWidth, 2)];
        
        [self addSubview:horizontalImg];
        if (i == _leftTitleArray.count - 1) {
            _leftLastLabelH = 25 + i * titleMargin + UULabelHeight;
           [self drawDashLine:horizontalImg lineLength:3 lineSpacing:0 lineColor:[UIColor colorWithRed:0.96 green:0.96 blue:0.96 alpha:1] direction:NO];
        }else{
            [self drawDashLine:horizontalImg lineLength:3 lineSpacing:2 lineColor:[UIColor colorWithRed:0.96 green:0.96 blue:0.96 alpha:1] direction:NO];
        }
        
    }
    

    CGFloat lineW = lineWidth;
    CGFloat bottomTitleMargin = lineW/5.0;
    for (int i = 0; i < _horizontaltitleArray.count; i++) {


        UILabel *title = [[UILabel alloc] initWithFrame:CGRectMake(UULabelwidth + i*bottomTitleMargin - 25, _leftLastLabelH, 50, 20)];
        title.font = [UIFont systemFontOfSize:13];
        title.text = [NSString stringWithFormat:@"%@",_horizontaltitleArray[i]];
        title.textAlignment = NSTextAlignmentCenter;
        title.textColor = _leftTitleColor;
        [self addSubview:title];
    }
    
    
}


/**
 ** lineView:	   需要绘制成虚线的view
 ** lineLength:	   虚线的宽度
 ** lineSpacing:   虚线的间距
 ** lineColor:	   虚线的颜色
 ** direction:     方向
 **/
- (void)drawDashLine:(UIView *)lineView lineLength:(int)lineLength lineSpacing:(int)lineSpacing lineColor:(UIColor *)lineColor direction:(BOOL)direction
{
    CAShapeLayer *shapeLayer = [CAShapeLayer layer];
    
    [shapeLayer setBounds:lineView.bounds];
    [shapeLayer setPosition:CGPointMake(CGRectGetWidth(lineView.frame) / 2, CGRectGetHeight(lineView.frame))];
    [shapeLayer setFillColor:[UIColor clearColor].CGColor];
    [shapeLayer setStrokeColor:lineColor.CGColor];
    
    [shapeLayer setLineWidth:2];
    [shapeLayer setLineJoin:kCALineJoinRound];
    [shapeLayer setLineDashPattern:[NSArray arrayWithObjects:[NSNumber numberWithInt:lineLength], [NSNumber numberWithInt:lineSpacing], nil]];
    CGMutablePathRef path = CGPathCreateMutable();
    
    if (direction) {
        CGPathMoveToPoint(path, NULL, CGRectGetWidth(lineView.frame), -20);
        CGPathAddLineToPoint(path, NULL, CGRectGetWidth(lineView.frame), CGRectGetHeight(lineView.frame)-20);
    }else{
        CGPathMoveToPoint(path, NULL, 0, 0);
        CGPathAddLineToPoint(path, NULL, CGRectGetWidth(lineView.frame), 0);
    }
    
    [shapeLayer setPath:path];
    CGPathRelease(path);
    
    [lineView.layer addSublayer:shapeLayer];
    
  
}


//获得当前画板
- (void)drawRect:(CGRect)rect
{
    
    [super drawRect:rect];

    [self initialization];
    //获得当前画板
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    if (_dataArray > 0) {
        [self drwaLineLeft:context];
    }
    
    if (_dataArray1 > 0) {
        [self drawLineRight:context];
    }
}

- (void)drwaLineLeft:(CGContextRef)context {
    //设置路径
    CGMutablePathRef path = CGPathCreateMutable();
    //颜色
    CGContextSetStrokeColorWithColor(context, _leftTitleColor.CGColor); // 线条红色
    
    // 设置填充颜色（路径闭合起来的区域）
    CGContextSetFillColorWithColor(context,_FillColor.CGColor);
    //画线的宽度
    CGContextSetLineWidth(context, 1);
    
    
    
    NSDictionary *dict = [_dataArray firstObject];
    CGFloat height1 = [dict[@"height"] floatValue];
    float percentageHeight1 = height1/100.0;
    //顶部横线
    CGPathMoveToPoint(path,NULL, UULabelwidth, 25*(1+0.5) + (1-percentageHeight1)* 125);
    
    NSString *sumKM = [_horizontaltitleArray lastObject];
    sumKM = [sumKM substringToIndex:4];
    float totalKM = [sumKM floatValue] * 1000;
    
    for (int i = 1; i < _dataArray.count; i++) {
        NSDictionary *dict = [_dataArray objectAtIndex:i];
        CGFloat km = [dict[@"km"] floatValue];
        CGFloat height = [dict[@"height"] floatValue];
        
        float percentageKM = km/totalKM;
        float percentageHeight = height/100.0;
        CGFloat y = 25*(1+0.5) + (1-percentageHeight)* 125;
        NSLog(@"%f",y);
        
        CGFloat x = percentageKM * (lineWidth) + UULabelwidth;
        CGPathAddLineToPoint(path,NULL, x,y);
    }
    
    CGPathAddLineToPoint(path,NULL, UULabelwidth,162.5);
    //    CGPathAddLineToPoint(path,NULL,UULabelwidth, 25*(1+0.5) + (1-percentageHeight1)* 125);
    // 3. 向上下文中 添加路径
    CGContextAddPath(context, path);
    //绘制路径
    CGContextDrawPath(context, kCGPathFillStroke);
    
    //6.路径使用完之后，释放
    CGPathRelease(path);
}

- (void)drawLineRight:(CGContextRef)context
{
    //设置路径
    CGMutablePathRef path = CGPathCreateMutable();
    //颜色
    CGContextSetStrokeColorWithColor(context, _rightTitleColor.CGColor); // 线条红色
    
    //画线的宽度
    CGContextSetLineWidth(context, 1);
    
    
    
    NSDictionary *dict = [_dataArray1 firstObject];
    CGFloat height1 = [dict[@"height"] floatValue];
    float percentageHeight1 = height1/100.0;
    //顶部横线
    CGPathMoveToPoint(path,NULL, UULabelwidth, 25*(1+0.5) + (1-percentageHeight1)* 125);
    
    NSString *sumKM = [_horizontaltitleArray lastObject];
    sumKM = [sumKM substringToIndex:4];
    float totalKM = [sumKM floatValue] * 1000;
    
    for (int i = 1; i < _dataArray1.count; i++) {
        NSDictionary *dict = [_dataArray1 objectAtIndex:i];
        CGFloat km = [dict[@"km"] floatValue];
        CGFloat height = [dict[@"height"] floatValue];
        
        float percentageKM = km/totalKM;
        float percentageHeight = height/100.0;
        CGFloat y = 25*(1+0.5) + (1-percentageHeight)* 125;
        NSLog(@"%f",y);
        
        CGFloat x = percentageKM * (lineWidth) + UULabelwidth;
        CGPathAddLineToPoint(path,NULL, x,y);
    }
    
    //    CGPathAddLineToPoint(path,NULL,UULabelwidth, 25*(1+0.5) + (1-percentageHeight1)* 125);
    // 3. 向上下文中 添加路径
    CGContextAddPath(context, path);
    //绘制路径
    CGContextDrawPath(context, kCGPathStroke);
    
    //6.路径使用完之后，释放
    CGPathRelease(path);
}


@end
